using Ocelot.Configuration.Builder;
using Ocelot.Configuration.File;

namespace Ocelot.Configuration.Creator
{
    public class AuthenticationOptionsCreator : IAuthenticationOptionsCreator
    {
        public AuthenticationOptions Create(FileReRoute fileReRoute)
        {
            var authenticationConfig = new IdentityServerConfigCreator().Create(fileReRoute.AuthenticationOptions);

            return new AuthenticationOptionsBuilder()
                .WithProvider(fileReRoute.AuthenticationOptions?.Provider)
                .WithAllowedScopes(fileReRoute.AuthenticationOptions?.AllowedScopes)
                .WithIdntityServerConfigConfiguration(authenticationConfig)
                .Build();
        } 
    }

    public class IdentityServerConfigCreator
    {
        public IdentityServerConfig Create(FileAuthenticationOptions authenticationOptions)
        {
            return new IdentityServerConfigBuilder()
                .WithApiName(authenticationOptions.IdentityServerConfig?.ApiName)
                .WithApiSecret(authenticationOptions.IdentityServerConfig?.ApiSecret)
                .WithProviderRootUrl(authenticationOptions.IdentityServerConfig?.ProviderRootUrl)
                .WithRequireHttps(authenticationOptions.IdentityServerConfig.RequireHttps).Build();
        }
    }
}